/***********************************************************************
                          main.c  -  description
                          ----------------------
    begin                : Mit Apr 17 22:22:30 CEST 2001
    update               : Mit November 06 21:12:15 CEST 2002
    copyright            : (C) 2001 by Georg P. Loczewski
    email                : gpl@lambda-bound.de
 **********************************************************************/

/***********************************************************************
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
***********************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#include <setjmp.h>
#include <malloc.h>
#include "gc.h"
#include <string.h>
#include "arsc.h"
#include "test.h"

extern ENV *globalEnv;
extern EXP *currentExp;
extern EXP *trueSym;

extern int true;

jmp_buf _EXH;

VALUE *
make_account (ENV * env)
{
  VALUE *clam_get_balance;
  VALUE *clam_deposit;
  VALUE *clam_withdraw;
  VALUE *clam_print_balance;
  VALUE *clam_self;

  clam_get_balance = newCLAMV (NULL,get_balance, env);
  clam_deposit  = newCLAMV (ncons(defName("amount"), NULL),deposit, env);
  clam_withdraw = newCLAMV (ncons(defName("amount"),NULL),withdraw, env);
  clam_print_balance = newCLAMV (NULL,print_balance, env);
  clam_self = newCLAMV (ncons(defName("msg"),NULL), self, env);
  defVar (defName ("get_balance"), clam_get_balance, env);
  defVar (defName ("deposit"), clam_deposit, env);
  defVar (defName ("withdraw"), clam_withdraw, env);
  defVar (defName ("print_balance"), clam_print_balance, env);
  return clam_self;
}

VALUE *
get_balance (ENV * env)
{
  return getVar (defName ("balance"), env);
}

VALUE *
deposit (ENV * env)
{
  VALUE *balance;
  VALUE *amount;
  int ba, am;

  balance = getVar (defName ("balance"), env);
  amount = getVar (defName ("amount"), env);
  ba = balance->val.ival;
  am = amount->val.ival;
  balance->val.ival = ba + am;
  setVar (defName ("balance"), balance, env);
  return balance;
}

VALUE *
withdraw (ENV * env)
{
  VALUE *balance;
  VALUE *amount;
  int ba, am;

  balance = getVar (defName ("balance"), env);
  amount = getVar (defName ("amount"), env);
  ba = balance->val.ival;
  am = amount->val.ival;
  balance->val.ival = ba - am;
  setVar (defName ("balance"), balance, env);
  return balance;
}

VALUE *
print_balance (ENV * env)
{
  VALUE *balance;

  balance = getVar (defName ("balance"), env);
  printf ("balance: ");
  prValue (balance);
  printf ("\n");
  return balance;
}

VALUE *
self (ENV * env)
{
  VALUE *ret;
  VALUE *vmsg;
  int msg;

  vmsg = getVar (defName ("msg"), env);
  msg = vmsg->val.ival;
  switch (msg) {
  case 1:
    ret = getVar (defName ("get_balance"), env);
    break;
  case 2:
    ret = getVar (defName ("deposit"), env);
    break;
  case 3:
    ret = getVar (defName ("withdraw"), env);
    break;
  case 4:
    ret = getVar (defName ("print_balance"), env);
    break;
  default:
    printf ("message not understood by object\n");
    longjmp (_EXH, 1);
  }
  return ret;
}

VALUE * 
konto (ENV * env)
{
  VALUE *clam_make_account;
  VALUE *k1;
  VALUE *k2;
  VALUE *print1;
  VALUE *print2;
  VALUE *result;
  VLIST *vl;

  clam_make_account = newCLAMV(ncons(defName("balance"),NULL),
		             make_account, 
			     env);
  vl = vcons (newINTV (10), NULL);
  k1 = apply (clam_make_account, vl);/* (define k1 (make-account ten)) */
  vl = vcons (newINTV (5), NULL);
  k2 = apply (clam_make_account, vl);/*(define k2 (make-account five)) */

  vl = vcons (newINTV (4), NULL);
  print1 = apply (k1, vl);	/* (k1 msg-print) */
  result = apply (print1, NULL);	/* ((k1 msg-print)) */
  vl = vcons (newINTV (2), NULL);
  result = apply (k1, vl);	/* (k1 msg-deposit) */
  vl = vcons (newINTV (10), NULL);
  result = apply (result, vl);	/* ((k1 msg-deposit) ten) */
  result = apply (print1, NULL);	/* ((k1 msg-print)) */
  vl = vcons (newINTV (3), NULL);
  result = apply (k1, vl);	/* (k1 msg-withdraw) */
  vl = vcons (newINTV (4), NULL);
  result = apply (result, vl);	/* ((k1 msg-withdraw) four) */
  print1 = apply (print1, NULL);	/* ((k1 msg-print)) */

  vl = vcons (newINTV (4), NULL);
  print2 = apply (k2, vl);	/* (k2 msg-print) */
  result = apply (print2, NULL);	/* ((k2 msg-print)) */
  vl = vcons (newINTV (2), NULL);
  result = apply (k2, vl);	/* (k2 msg-deposit) */
  vl = vcons (newINTV (9), NULL);
  result = apply (result, vl);	/* ((k2 msg-deposit) nine) */
  result = apply (print2, NULL);	/* ((k2 msg-print)) */
  vl = vcons (newINTV (3), NULL);
  result = apply (k2, vl);	/* (k2 msg-withdraw) */
  vl = vcons (newINTV (7), NULL);
  result = apply (result, vl);	/* ((k2 msg-withdraw) seven) */
  print2 = apply (print2, NULL);	/* ((k2 msg-print)) */
  /*vl = cons(newINTV(3), cons(newINTV(2),cons(newINTV(1),NULL)));
     result = newLISTV(vl);
     prValue(result); */
  return result;
}

void
ootest ()
{
  ENV *penv;
  VALUE *result;
  VALUE *clam_konto;

  penv = emptyEnv ();
  clam_konto = newCLAMV(NULL, konto, penv);
  result = apply (clam_konto, NULL);
}

VALUE *
car (ENV * env)
{
  VALUE *l;

  l = getVar (defName ("l"), env);
  if (l->type == LISTV) {
    return l->val.lv.car;
  }
  else {
    printf ("wrong argument type for car\n");
    longjmp (_EXH, 2);
  }
}

VALUE *
cdr (ENV * env)
{
  VALUE *l;

  l = getVar (defName ("l"), env);
  if (l->type == LISTV) {
    return l->val.lv.cdr;
  }
  else {
    printf ("wrong argument type for cdr\n");
    longjmp (_EXH, 2);
  }
}

VALUE *
compose_aux (ENV * env)
{
  VALUE *f;
  VALUE *g;
  VALUE *x;
  VALUE *result;

  f = getVar (defName ("f"), env);
  g = getVar (defName ("g"), env);
  x = getVar (defName ("x"), env);
  result = apply (g, vcons (apply (f, vcons (x, NULL)), NULL));
  return result;
}

VALUE *
compose (ENV * env)
{
  return newCLAMV(ncons (defName ("x"), NULL), 
		compose_aux,
		env);
}

void
futest ()
{
  ENV *penv;
  VALUE *result;
  VALUE *cadr;
  VALUE *clam_car;
  VALUE *clam_cdr;
  VALUE *clam_compose;
  VLIST *vl;

  penv = emptyEnv ();
  vl =
    vcons(cons(newINTV (2),
	       cons(newINTV(3),
		    cons(newINTV(4),
			 cons(newINTV(6),
			      NULL)))), NULL);
  clam_car = newCLAMV (ncons(defName ("l"),NULL),car, penv);
  clam_cdr = newCLAMV (ncons(defName ("l"),NULL),cdr, penv);
  clam_compose = newCLAMV (ncons(defName("f"), ncons(defName("g"),NULL)),
		         compose, 
			 penv);
  cadr = apply (clam_compose, vcons(clam_cdr,vcons(clam_car, NULL)));
  result = apply (cadr, vl);
  prValue (result);
  printf ("\n");
}

  
 
int
main (int argc, char *argv[])
{
  int ret;

  //malloc_stats ();
  initNames ();
  parserinit (stdin);
  initGlobalEnv ();
  load (newSTRV(defName("init.ars")));
  if (argc > 1) {
    switch (argv[1][1]) {
    case 'i':
      ret = setjmp (_EXH);
      if (ret == 1)
	goto _LBREAK;
      if (ret == 2)
	goto _LQUIT;
      goto _LBREAK;
    case 'o':
      ret = setjmp (_EXH);
      if (ret == 1 || ret == 2)
	goto _LQUIT;
      printf ("test of object oriented  programming style:\n");
      ootest ();
      longjmp (_EXH, 2);
    case 'f':
      ret = setjmp (_EXH);
      if (ret == 1 || ret == 2)
	goto _LQUIT;
      printf ("test of functional programming style:\n");
      futest ();
      longjmp (_EXH, 2);
    default:
      printf ("undefined option: %s\n", argv[1]);
      longjmp (_EXH, 2);
    }
  }
  else {
     ret = setjmp (_EXH);
     if (ret == 1)
        goto _LBREAK;
     if (ret == 2)
        goto _LQUIT;
     goto _LBREAK;
  }
_LBREAK:
  while (1) {
     currentExp = readWithPrompt ();
     prValue (evalThunk (eval (currentExp, globalEnv, trueSym)));
     printf ("\n\n");
  }
_LQUIT:
  //malloc_stats ();
  return EXIT_SUCCESS;
}
